#ifndef WAVSTATS_H
#include "wavstats.h"
#endif

#include <QTextStream>

#include <cmath> // for log10
#include <sstream>

std::vector<double> vsamps;

void displaySF_INFO( QPlainTextEdit* pte )
{
    QString qs;
    qs = QString( "SF_INFO frames %L1" ).arg( mysfinfo.frames );
    pte->appendPlainText( qs );

    qs = QString( "SF_INFO format %1 hex " ).arg( mysfinfo.format, 0, 16 );
    pte->appendPlainText( qs );
    pte->appendPlainText( "     0x10000 is Microsoft WAV format(little endian)" );
    pte->appendPlainText( "      0x0001 is signed 8 bit data" );
    pte->appendPlainText( "      0x0002 is signed 16 bit data" );
    pte->appendPlainText( "      0x0003 is signed 24 bit data" );
    pte->appendPlainText( "      0x0004 is signed 32 bit data" );
    pte->appendPlainText( "      0x0005 is unsigned 8 bit data" );
    pte->appendPlainText( "      0x0006 is 32 bit float data" );
    pte->appendPlainText( "      0x0007 is 64 bit float data" );

    qs = QString( "SF_INFO channels %1" ).arg( mysfinfo.channels );
    pte->appendPlainText( qs );

    qs = QString( "SF_INFO samplerate %1" ).arg( mysfinfo.samplerate );
    pte->appendPlainText( qs );
}

// Utility calculations
MY_TYPE calc_dB( MY_TYPE f1, MY_TYPE f2 )
{
    // use code from from hw812/hw813
}

MY_TYPE getDCoffset( const std::vector<MY_TYPE>& v )
{
    MY_TYPE sum = std::accumulate( v.begin(), v.end(), 0.0 );
    size_t sz = v.size();
    sum /= sz;
    return sum;
}

MY_TYPE getMinSample( const std::vector<MY_TYPE>& v )
{
    // use code from from hw812/hw813
}

MY_TYPE getMaxSample( const std::vector<MY_TYPE>& v )
{
    // use code from from hw812/hw813
}

MY_TYPE getPeakdB( const std::vector<MY_TYPE>& v )
{
    // use code from from hw812/hw813
}

MY_TYPE getRMSamplitude( const std::vector<MY_TYPE>& v )
{
    // use code from from hw812/hw813
}

// Display calculations
void doCalcNumSamples( QPlainTextEdit* pte )
{
    // use code from from hw812/hw813
}

void doCalcLengthSeconds( QPlainTextEdit* pte )
{
    // use code from from hw812/hw813
}

void doCalcDCOffset( QPlainTextEdit* pte )
{
    // use code from from hw812/hw813
}

void doCalcMinSample( QPlainTextEdit* pte )
{
    // use code from from hw812/hw813
}

void doCalcMaxSample( QPlainTextEdit* pte )
{
    // use code from from hw812/hw813
}

void doCalcMaxSample_dB( QPlainTextEdit* pte )
{
    // use code from from hw812/hw813
}

void doCalcRMSAmplitude( QPlainTextEdit* pte )
{
    // use code from from hw812/hw813
}

void doCalcPeakCount( QPlainTextEdit* pte )
{
    // use code from from hw812/hw813
}

void doCountClipping( QPlainTextEdit* pte )
{
    // use code from from hw812/hw813
}

void displayStats( QPlainTextEdit* pte )
{
    doCalcNumSamples( pte );
    doCalcLengthSeconds( pte );
    doCalcDCOffset( pte );
    doCalcMinSample( pte );
    doCalcMaxSample( pte );
    doCalcMaxSample_dB( pte );
    doCalcRMSAmplitude( pte );
    doCalcPeakCount( pte );
    doCountClipping( pte );
}
